<?php
namespace Nitsan\NitsanMaintenance\Controller;

/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * MaintenanceController
 */
class MaintenanceController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{

    /**
     * maintenanceRepository
     *
     * @var \Nitsan\NitsanMaintenance\Domain\Repository\MaintenanceRepository
     * @inject
     */
    protected $maintenanceRepository = NULL;
    
    protected function initializeCreateAction()
    {
        if (isset($this->arguments['newMaintenance'])) {
            $this->arguments['newMaintenance']->getPropertyMappingConfiguration()->forProperty('startdate')->setTypeConverterOption('TYPO3\\CMS\\Extbase\\Property\\TypeConverter\\DateTimeConverter', \TYPO3\CMS\Extbase\Property\TypeConverter\DateTimeConverter::CONFIGURATION_DATE_FORMAT, 'Y-m-d H:i:s');
            $this->arguments['newMaintenance']->getPropertyMappingConfiguration()->forProperty('enddate')->setTypeConverterOption('TYPO3\\CMS\\Extbase\\Property\\TypeConverter\\DateTimeConverter', \TYPO3\CMS\Extbase\Property\TypeConverter\DateTimeConverter::CONFIGURATION_DATE_FORMAT, 'Y-m-d H:i:s');
        }
    }
    
    /**
     * action list
     *
     * @return void
     */
    public function listAction()
    {
        $maintenances = $this->maintenanceRepository->findAll();
        $this->view->assign('newMaintenance', $maintenances[0]);
    }
    
    /**
     * action new
     *
     * @return void
     */
    public function newAction()
    {
        
    }
    
    /**
     * action create
     *
     * @param \Nitsan\NitsanMaintenance\Domain\Model\Maintenance $newMaintenance
     * @return void
     */
    public function createAction(\Nitsan\NitsanMaintenance\Domain\Model\Maintenance $newMaintenance)
    {
        $newMaintenance->setStartdate(strtotime($newMaintenance->getStartdate()));
        $newMaintenance->setEnddate(strtotime($newMaintenance->getEnddate()));
        if ($maintenances = $this->maintenanceRepository->findAll()->count() > 0) {
            $this->maintenanceRepository->update($newMaintenance);
        } else {
            $this->maintenanceRepository->add($newMaintenance);
        }
        $this->addFlashMessage('Settings were updated', '', \TYPO3\CMS\Core\Messaging\AbstractMessage::OK);
        $this->view->assign('maintenances', $newMaintenance);
        $this->redirect('list');
    }
    
    /**
     * action create
     *
     * @return void
     */
    public function pageAction()
    {
        $maintenanceSettings = $this->maintenanceRepository->findAll();
        $maintenanceSettings[0]->setStartdate(date('d-m-Y H:i:s', $maintenanceSettings[0]->getStartdate()));
        $maintenanceSettings[0]->setEnddate(date('d-m-Y H:i:s', $maintenanceSettings[0]->getEnddate()));
        $this->view->assign('settings', $maintenanceSettings[0]);
    }

}